//in uso


#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
#include "RemoteDebug.h"        //https://github.com/JoaoLopesF/RemoteDebug
RemoteDebug Debug;
#include <PubSubClient.h>
#include "Adafruit_MQTT.h"
#include "Adafruit_MQTT_Client.h"

unsigned long previousMillis = 0;
const long interval = 15000;
WiFiClient Caldaia;
PubSubClient client(Caldaia);
// Time
uint32_t mLastTime = 0;
uint32_t mTimeSeconds = 0;
uint32_t LastTime = 0;
uint32_t TimeSeconds = 0;
#define HOST_NAME "Caldaia"

const char* ssid = "NomeDellaTuaReteWireless";
const char* password = "PasswordDellaTuaReteWireless";
const char* mqtt_server = "192.168.1.123";  //<-- IP del tuo RaspberryPi

const char* clientID = "Caldaia";
const char* outTopic = "Power";

const char* outTopic1 = "HOME/Termostato/RecoveryTemperature";
const char* outTopic2 = "HOME/Termostato/RecoveryHumidity";
const char* outTopic3 = "HOME/Termostato/RecoveryTargetHCS";
const char* questionMSG = "???";
const char* inTopic1 = "HOME/Termostato/Current/HCS";
const char* inTopic3 = "HOME/Termostato/getall";
const char* inTopic4 = "HOME/Termostato/Target/Humidity";
const char* inTopic5 = "HOME/Termostato/Target/Temperature";
const char* inTopic6 = "HOME/Termostato/Target/Hcs";
const char* inTopic7 = "HOME/Termostato/Current/Temperature";

const byte hotPin = D1;
int storeHCS = 0;
int currHCS = 0;
int tarHCS = 0;
int tarHum = 35;
int tarTem = 25;
float curTem = 20;
char msg[50];

//********************************************************************************************** CALLBACK
void callback(char* topic, byte* payload, unsigned int length) {
  payload[length] = '\0'; // Null terminator used to terminate the char array
  String message = (char*)payload;

  if (strcmp (topic, inTopic1) == 0) {                      //HOME/Termostato/Current/HCS
    char receivedAll2[length];
    for (int x = 0; x < length; x++) {
      char receivedChar = (char)payload[x];
      receivedAll2[x] = receivedChar;
    }
    currHCS = atoi (receivedAll2);
  }
  if (strcmp (topic, inTopic4) == 0) {                      //  HOME/Termostato/Target/Humidity";
    char receivedAll2[length];
    for (int x = 0; x < length; x++) {
      char receivedChar = (char)payload[x];
      receivedAll2[x] = receivedChar;
    }
    tarHum = atoi (receivedAll2);
  }
  if (strcmp (topic, inTopic5) == 0) {                        //"HOME/Termostato/Target/Temperature";
    char receivedAll2[length];
    for (int x = 0; x < length; x++) {
      char receivedChar = (char)payload[x];
      receivedAll2[x] = receivedChar;
    }
    tarTem = atoi (receivedAll2);
  }
  if (strcmp (topic, inTopic3) == 0) {                        //"HOME/Termostato/getall";
    dtostrf(tarHCS , 0, 0, msg);
    client.publish (outTopic3, msg);
    dtostrf(tarHum , 0, 0, msg);
    client.publish (outTopic2, msg);
    dtostrf(tarTem , 0, 0, msg);
    client.publish (outTopic1, msg);
  }
  if (strcmp (topic, inTopic6) == 0) {                        //"HOME/Termostato/Target/HCS";
    char receivedAll2[length];
    for (int x = 0; x < length; x++) {
      char receivedChar = (char)payload[x];
      receivedAll2[x] = receivedChar;
    }
    tarHCS = atoi (receivedAll2);
  }
  if (strcmp (topic, inTopic7) == 0) {                      //"HOME/Termostato/Current/Temperature";
    char receivedAll2[length];
    for (int x = 0; x < length; x++) {
      char receivedChar = (char)payload[x];
      receivedAll2[x] = receivedChar;
    }
    curTem = atof (receivedAll2);
  }

  Debug.println();
}
//********************************************************************************************* RECONNECT
void reconnect() {
  while (!client.connected()) {
    Debug.println("Attempting MQTT connection...");
    if (client.connect(clientID)) {
      Debug.println("connected");
      // Once connected, publish an announcement...
      client.publish(outTopic, clientID);
      client.publish("HOME/Termostato/getallFromT", "info");
      // ... and subscribe to topic
      client.subscribe(inTopic1);
      client.subscribe(inTopic3);
      client.subscribe(inTopic4);
      client.subscribe(inTopic5);
      client.subscribe(inTopic6);
      client.subscribe(inTopic7);
      client.subscribe("get/#");
    } else {
      Debug.print("failed, rc=");
      Debug.print(client.state());
      Debug.println(" try again in 5 second");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}
//************************************************************************************************* SETUP
void setup() {
  Serial.begin(115200);
  Debug.begin(HOST_NAME);
  Debug.setSerialEnabled(true);
  Debug.setResetCmdEnabled(true); // Enable the reset command
  ConnectWifi();
  while (WiFi.waitForConnectResult() != WL_CONNECTED) {
    delay (2000);
    ConnectWifi();
  }
  OTA();
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
  pinMode(hotPin, OUTPUT);
  digitalWrite(hotPin, LOW);
}
//************************************************************************************************** LOOP
void loop() {
  if (WiFi.waitForConnectResult() != WL_CONNECTED)
    ConnectWifi();
  if (!client.connected())
    reconnect();
  ArduinoOTA.handle();
  Debug.handle();

  if ((millis() - mLastTime) >= 1000) {
    mLastTime = millis();
    mTimeSeconds++;
    if (mTimeSeconds % 15 == 0) { // Each 5 seconds
      rdebugVln("* This is a message of debug level VERBOSE");
      rdebugDln("* This is a message of debug level DEBUG");
      rdebugIln("* This is a message of debug level INFO");
      rdebugWln("* This is a message of debug level WARNING");
      rdebugEln("* This is a message of debug level ERROR");
      pubCurrentHCS();
    }
    if (mTimeSeconds % 5 == 0) {
      if ((currHCS == 1) && (tarTem > curTem)) {
        digitalWrite(hotPin, HIGH);
      } else if ((currHCS != 1) || (curTem >= tarTem)) {
        digitalWrite(hotPin, LOW);       
      }
    }
    if (mTimeSeconds % 2 == 0) {     
      Debug.print("target  HCS:"); Debug.println(tarHCS);
      Debug.print("current HCS:"); Debug.println(currHCS);
      Debug.print("target  Tem:"); Debug.println(tarTem);
      Debug.print("target  Hum:"); Debug.println(tarHum);
    }
  }
  setCurrentHCS();
  yield();
  client.loop();
}
//****************************************************************************************** CONNECT WIFI
bool ConnectWifi() {
  WiFi.mode(WIFI_STA);
  WiFi.disconnect();
  delay(100);
  WiFi.begin(ssid, password);
}
//**************************************************************************************** SET CurrentHCS
void setCurrentHCS() {
  if (tarHCS == 0)
    currHCS = 0;
  if ((tarHCS == 1) && tarTem > curTem)
    currHCS = 1;
  if ((tarHCS == 1) && tarTem <= curTem)
    currHCS = 0;
  if ((tarHCS == 2) && tarTem < curTem)
    currHCS = 2;
  if  ((tarHCS == 2) && tarTem >= curTem)
    currHCS = 0;
  if  ((tarHCS == 3) && tarTem > curTem)
    currHCS = 1;
  if  ((tarHCS == 3) && tarTem == curTem)
    currHCS = 0;
  if  ((tarHCS == 3) && tarTem < curTem)
    currHCS = 2;
}
//**************************************************************************************** PUB currentHCS
void pubCurrentHCS() {
  if (currHCS != storeHCS) {
    dtostrf(currHCS , 0, 0, msg);
    client.publish(inTopic1, msg);
    if (currHCS == 0)
      digitalWrite(hotPin, HIGH);
    else
      digitalWrite(hotPin, LOW);
    storeHCS = currHCS;
  }
}
//*************************************************************************************** OTA
void OTA() {
  ArduinoOTA.setPort(8266);
  ArduinoOTA.setHostname(HOST_NAME);
  //ArduinoOTA.setPassword((const char *)"123");
  ArduinoOTA.onStart([]() {
    Debug.println("Start");
  });
  ArduinoOTA.onEnd([]() {
    Debug.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Debug.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Debug.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) Debug.println("Auth Failed");
    else if (error == OTA_BEGIN_ERROR) Debug.println("Begin Failed");
    else if (error == OTA_CONNECT_ERROR) Debug.println("Connect Failed");
    else if (error == OTA_RECEIVE_ERROR) Debug.println("Receive Failed");
    else if (error == OTA_END_ERROR) Debug.println("End Failed");
  });
  ArduinoOTA.begin();
}
